----
-- $Rev: 48 $:     Revision der letzten Änderung
-- $Author: FoxAlpha $:  Author der letzten Änderung
-- $Date: 2012-12-22 04:19:50 +0100 (Sa, 22. Dez 2012) $:    Date der letzten Änderung
----

print("loading Clock-MOD LS2013 v1.1");

----
--	ClockMod v1.1 by Fox-Alpha
----

ClockMod = {};
ClockMod.moddir		= g_currentModDirectory;
ClockMod.modName 	= g_currentModName;


source(g_currentModDirectory .. "clockmodconfiguration.lua");
source(g_currentModDirectory .. "clockmodconsole.lua");


function ClockMod:loadMap(name)
	self.startzeit = getTime();

	self.language = g_languageShort;
	self.counter = true;
	
	self.cmEnabled = true;
	
	self.cmVersion = 0;
	
	if g_i18n:hasText("cmTimeFormat") then
		self.timform = g_i18n:getText("cmTimeFormat");
	else
		self.timform = 12;
	end;
	
	----
	--	Tabelle für Textfarben
	----
	self.txtColors ={};
	self.txtColors.date ={r=1, g=1, b=1, a=1};
	self.txtColors.time ={r=1, g=1, b=1, a=1};
	self.txtColors.title ={r=1, g=1, b=1, a=1};
	self.txtColors.data ={r=1, g=1, b=1, a=1};
	----
	
	----
	-- Tabelle für Wecker
	---
	self.cmAlarm = {};
	self.cmAlarm.time = {hour=0, minute=0, enabled=false};
	self.cmAlarm.soundfile = 0;
	---
	
	----
	-- Tabelle für Counter
	---
	self.cmCounter = {};
	self.cmCounter.time = {minute=0, enabled=false};
	self.cmCounter.soundfile = 0;
	---
	
	----
	--	Panel Default Daten
	----
	self.cmPanel = {};
	self.cmPanel.text = {};
	self.cmPanel.title = {};
	self.cmPanel.indent = {date=0.008, time=0.007813, data=0.115, title=0.007813};
	self.cmPanel.fontsize = {date=0.019, time=0.026, data=0.017, title=0.017};
	self.cmPanel.usePanel = false;
	self.cmPanel.position = {x=0.630000, y=0.895000, w=0.175000};
	self.cmPanel.files = {valid=false,fileTop={file=Utils.getFilename("panel/panelTop.dds", self.moddir), height=0.007813, overlayID=0}, fileMid={valid=false,file=Utils.getFilename("panel/panelMid.dds", self.moddir), height=0.0625, overlayID=0}, fileBot={valid=false,file=Utils.getFilename("panel/panelBottom.dds", self.moddir), height=0.007813, overlayID=0}};
	----
	
	----
	-- Standardwerte zwischenspeichern
	----
	self.default = {};
	
	self.default.colors = {};
	self.default.colors.date ={r=1, g=1, b=1, a=1};
	self.default.colors.time ={r=1, g=1, b=1, a=1};
	self.default.colors.title ={r=1, g=1, b=1, a=1};
	self.default.colors.data ={r=1, g=1, b=1, a=1};
	
	self.default.panel = {};
	self.default.panel.text = {};
	self.default.panel.title = {};
	self.default.panel.indent = {date=0.008, time=0.007813, data=0.115, title=0.007813};
	self.default.panel.fontsize = {date=0.019, time=0.026, data=0.017, title=0.017};
	self.default.panel.usePanel = false;
	self.default.panel.position = {x=0.630000, y=0.895000, w=0.175000};
	self.default.panel.files = {valid=false,fileTop={file=Utils.getFilename("panel/panelTop.dds", self.moddir), height=0.007813, overlayID=0}, fileMid={valid=false,file=Utils.getFilename("panel/panelMid.dds", self.moddir), height=0.079000, overlayID=0}, fileBot={valid=false,file=Utils.getFilename("panel/panelBottom.dds", self.moddir), height=0.007813, overlayID=0}};

	self.default.alarm = {};
	self.default.alarm.time = {hour=0, minute=0, enabled=false};
	self.default.alarm.soundfile = 0;

	self.default.timer = {};
	self.default.timer.time = {minute=0, enabled=false};
	self.default.timer.soundfile = 0;
	----
	
	self.months = {};
    self.months[01] = "Jan";
    self.months[02] = "Feb";
    self.months[03] = "Maer";
    self.months[04] = "Apr";
    self.months[05] = "Mai";
    self.months[06] = "Jun";
    self.months[07] = "Jul";
    self.months[08] = "Aug";
    self.months[09] = "Sep";
    self.months[10] = "Okt";
    self.months[11] = "Nov";
    self.months[12] = "Dez";

	self.days = {};
	self.days[1] = "Sonntag";
	self.days[2] = "Montag";
	self.days[3] = "Dienstag";
	self.days[4] = "Mittwoch";
	self.days[5] = "Donnerstag";
	self.days[6] = "Freitag";
	self.days[7] = "Samstag";
	
	self.de_tag = self.days[tonumber(getDate("%w"))+1];
	self.curmon = getDate("%m")
	self.de_monat = self.months[tonumber(self.curmon)];

	local ptmd = string.gsub(self.moddir, self.modName.."/", "");
	local xmlfile = ptmd .. "ClockModConfig.xml";
	local xmlexists = fileExists(xmlfile);

	if xmlexists ~= true then
		self:createClockModConfig();
	end;	
	self:loadClockModConfig();
	
	----
	-- Registrieren der Konsolen Befehle
	----
	self:registerConsoleCmd();
	----

	----
	--	Erzeugen der Overlays aus den aktualisierten Angaben
	----
	if self.cmPanel.usePanel then
		self:updatePanelOverlays();
	end;
	----
end;

function ClockMod:update(dt)
		
end;

function ClockMod:draw()
	if self.cmEnabled then
		----
		-- Datum anzeigen / Show Date
		----
		if self.language == "en" then
			self.cmPanel.text.Datetxt = getDate("%a, %d.%b %Y");
		elseif self.language == "de" then
			self.cmPanel.text.Datetxt = (self.de_tag..", "..getDate("%d").."."..self.de_monat.." "..getDate("%Y"));
		else
			self.cmPanel.text.Datetxt = getDate("%a, %d.%b %Y");
		end;
		----
		
		----
		-- Uhrzeit anzeigen / Show Time
		----
		if tonumber(self.timform) == 12 then
			self.cmPanel.text.Timetxt = getDate("%I:%M:%S ")..string.lower(getDate("%p"));
		elseif tonumber(self.timform) == 24 then
			self.cmPanel.text.Timetxt = getDate("%H:%M:%S");
		else
			self.cmPanel.text.Timetxt = getDate("%I:%M:%S ")..string.lower(getDate("%p"));
		end
		----
		
		----
		-- Spielzeit zeigen / Show Playtime
		----
		if self.counter then
			if g_i18n:hasText("cmPlayTimeAll") then
				self.cmPanel.title.PlayTimeAll = g_i18n:getText("cmPlayTimeAll");
				self.cmPanel.title.PlayTimeToday = g_i18n:getText("cmPlayTimeToday");
			else -- other
				self.cmPanel.title.PlayTimeAll = "all Playtime:";
				self.cmPanel.title.PlayTimeToday = "Played today:";
			end

			self.playhours = math.floor(g_currentMission.missionStats.playTime /60)
			self.playmins = g_currentMission.missionStats.playTime - (self.playhours * 60)

			if self.playmins >= 10 then
				self.cmPanel.text.PlayTimeAll = (string.format("%.0f", self.playhours)..":"..string.format("%.0f", self.playmins));
			else
				self.cmPanel.text.PlayTimeAll = (string.format("%.0f", self.playhours)..":0"..string.format("%.0f", self.playmins));
			end

			self.playhourssession = math.floor(g_currentMission.missionStats.playTimeSession /60)
			self.playminssession = g_currentMission.missionStats.playTimeSession - (self.playhourssession * 60)

			if self.playminssession >= 10 then
				self.cmPanel.text.PlayTimeToday = (string.format("%.0f", self.playhourssession)..":"..string.format("%.0f", self.playminssession));
			else
				self.cmPanel.text.PlayTimeToday = (string.format("%.0f", self.playhourssession)..":0"..string.format("%.0f", self.playminssession));
			end

		end;
		----
		
		----
		--	Panel erstellen
		----
		if self.cmPanel.usePanel then
			----
			--	Obere Panelgrafik
			----
			if self.cmPanel.files.fileTop.overlayID ~= nil and self.cmPanel.files.fileTop.overlayID ~=0 then
				renderOverlay(	self.cmPanel.files.fileTop.overlayID,
								self.cmPanel.position.x, 
								self.cmPanel.position.y+self.cmPanel.files.fileMid.height+self.cmPanel.files.fileBot.height, 
								self.cmPanel.position.w, 
								self.cmPanel.files.fileTop.height);
			else
				print("Obere Panelgrafik ist ungültig");
				self.cmPanel.files.fileTop.valid = false;
			end;
			----
							
			----
			--	Mittlere Panelgrafik
			----
			if self.cmPanel.files.fileMid.overlayID ~= nil and self.cmPanel.files.fileMid.overlayID ~=0 then
				renderOverlay(	self.cmPanel.files.fileMid.overlayID, 
								self.cmPanel.position.x, 
								self.cmPanel.position.y+self.cmPanel.files.fileBot.height, 
								self.cmPanel.position.w, 
								self.cmPanel.files.fileMid.height);
			else
				print("Mittlere Panelgrafik ist ungültig");
				self.cmPanel.files.fileMid.valid = false;
			end;
			----

			----
			--	Untere Panelgrafik
			----
			if self.cmPanel.files.fileBot.overlayID ~= nil and self.cmPanel.files.fileBot.overlayID ~=0 then
				renderOverlay(	self.cmPanel.files.fileBot.overlayID, 
								self.cmPanel.position.x, 
								self.cmPanel.position.y, 
								self.cmPanel.position.w, 
								self.cmPanel.files.fileBot.height);
			else
				print("Untere Panelgrafik ist ungültig");
				self.cmPanel.files.fileBot.valid = false;
			end;
			----
							
			----
			--	Texte im Panel darstellen
			----
			--  Datum ausgeben
			----
			setTextColor(self.txtColors.date.r,self.txtColors.date.g,self.txtColors.date.b,self.txtColors.date.a);
			----
			local tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date;
			
			renderText(self.cmPanel.position.x + self.cmPanel.indent.date,
						tY, self.cmPanel.fontsize.date, 
						self.cmPanel.text.Datetxt);
			----

			----
			--  Uhrzeit
			----
			setTextColor(self.txtColors.time.r, self.txtColors.time.g, self.txtColors.time.b, self.txtColors.time.a);
			----
			tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time;
			renderText(self.cmPanel.position.x + self.cmPanel.indent.time,
						tY, self.cmPanel.fontsize.time, 
						self.cmPanel.text.Timetxt);
			----

			----
			--  Ausgeben der gespielten Zeit
			----
			--	Farbe Beschriftung
			----
			setTextColor(self.txtColors.title.r, self.txtColors.title.g, self.txtColors.title.b, self.txtColors.title.a);
			----
			--	Spielzeit gesamt
			----
			tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.title;
			renderText(self.cmPanel.position.x + self.cmPanel.indent.title,
						tY, self.cmPanel.fontsize.title, 
						self.cmPanel.title.PlayTimeAll);
			----
			--	Spielzeit heute
			----
			tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height  - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.title - self.cmPanel.fontsize.title;
			renderText(self.cmPanel.position.x + self.cmPanel.indent.title,
						tY, self.cmPanel.fontsize.title, 
						self.cmPanel.title.PlayTimeToday);
						
			----
			--	Farbe Daten
			----
			setTextColor(self.txtColors.data.r, self.txtColors.data.g, self.txtColors.data.b, self.txtColors.data.a);
			----
			--	Daten, Spielzeit gesamt
			----
			tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.data;
			renderText(self.cmPanel.position.x + self.cmPanel.indent.data,
						tY, self.cmPanel.fontsize.data, 
						self.cmPanel.text.PlayTimeAll);
			----
			--	Daten, Spielzeit heute
			----
			tY = self.cmPanel.position.y + self.cmPanel.files.fileBot.height + self.cmPanel.files.fileMid.height - self.cmPanel.fontsize.date - self.cmPanel.fontsize.time - self.cmPanel.fontsize.data - self.cmPanel.fontsize.data;
			renderText(self.cmPanel.position.x + self.cmPanel.indent.data,
						tY, self.cmPanel.fontsize.data, 
						self.cmPanel.text.PlayTimeToday);
			----
		else	-- Kein Panel verwenden, Texte um die Uhr herum ausgeben
			----
			-- Datum ausgeben
			----
			setTextColor(self.txtColors.date.r, self.txtColors.date.g, self.txtColors.date.b, self.txtColors.date.a);
			renderText(0.83, 0.982, 0.02, self.cmPanel.text.Datetxt);
			----

			----
			-- Uhrzeit
			----
			setTextColor(self.txtColors.time.r, self.txtColors.time.g, self.txtColors.time.b, self.txtColors.time.a);
			renderText(0.87, 0.905, 0.018, self.cmPanel.text.Timetxt);
			----
			
			----
			-- Spielzeit zeigen / Show Playtime
			----
			setTextColor(self.txtColors.title.r, self.txtColors.title.g, self.txtColors.title.b, self.txtColors.title.a);
			renderText(0.83, 0.970, 0.013, self.cmPanel.title.PlayTimeAll);	
			renderText(0.83, 0.956, 0.013, self.cmPanel.title.PlayTimeToday);
			
			setTextColor(self.txtColors.data.r, self.txtColors.data.g, self.txtColors.data.b, self.txtColors.data.a);
			renderText(0.91, 0.970, 0.013, self.cmPanel.text.PlayTimeAll);		
			renderText(0.91, 0.957, 0.013, self.cmPanel.text.PlayTimeToday);		
			----
		end;
		----
	end;
	----
	setTextColor(1, 1, 1, 0);
end;

function ClockMod:mouseEvent(posX, posY, isDown, isUp, button)

end;

function ClockMod:keyEvent(unicode, sym, modifier, isDown)

end;

function ClockMod:deleteMap()

end;

function ClockMod:updatePanelOverlays()
	----
	--	Obere Panelgrafik
	----
	self.cmPanel.files.fileTop.overlayID = createImageOverlay(self.cmPanel.files.fileTop.file);
	if self.cmPanel.files.fileTop.overlayID ~= nil and self.cmPanel.files.fileTop.overlayID ~=0 then
		self.cmPanel.files.fileTop.valid = true;
	end;
	----
	
	----
	--	Mittlere Panelgrafik
	----
	self:setPanelMidHeight();
	----
	self.cmPanel.files.fileMid.overlayID = createImageOverlay(self.cmPanel.files.fileMid.file);
	if self.cmPanel.files.fileMid.overlayID ~= nil and self.cmPanel.files.fileMid.overlayID ~=0 then
		self.cmPanel.files.fileMid.valid = true;
	end;	
	----
	
	----
	--	Untere Panelgrafik
	----
	self.cmPanel.files.fileBot.overlayID = createImageOverlay(self.cmPanel.files.fileBot.file);
	if self.cmPanel.files.fileBot.overlayID ~= nil and self.cmPanel.files.fileBot.overlayID ~=0 then
		self.cmPanel.files.fileBot.valid = true;
	end;
	----

end;

function ClockMod:setPanelMidHeight()
	--- Größe der mittleren Grafik abhängig von den Fontgrößen
	self.cmPanel.files.fileMid.height = self.cmPanel.fontsize.date + self.cmPanel.fontsize.time;
	if self.cmPanel.fontsize.title > self.cmPanel.fontsize.data then
		self.cmPanel.files.fileMid.height = self.cmPanel.files.fileMid.height + 2*self.cmPanel.fontsize.title;
	else
		self.cmPanel.files.fileMid.height = self.cmPanel.files.fileMid.height + 2*self.cmPanel.fontsize.data;
	end;
end;

function table.show(t, name, indent)
   local cart     -- a container
   local autoref  -- for self references

   --[[ counts the number of elements in a table
   local function tablecount(t)
      local n = 0
      for _, _ in pairs(t) do n = n+1 end
      return n
   end
   ]]
   -- (RiciLake) returns true if the table is empty
   local function isemptytable(t) return next(t) == nil end

   local function basicSerialize (o)
      local so = tostring(o)
      if type(o) == "function" then
         local info = debug.getinfo(o, "S")
         -- info.name is nil because o is not a calling level
         if info.what == "C" then
            return string.format("%q", so .. ", C function")
         else 
            -- the information is defined through lines
            return string.format("%q", so .. ", defined in (" ..
                info.linedefined .. "-" .. info.lastlinedefined ..
                ")" .. info.source)
         end
      elseif type(o) == "number" then
         return so
      else
         return string.format("%q", so)
      end
   end
   local function addtocart (value, name, indent, saved, field)
      indent = indent or ""
      saved = saved or {}
      field = field or name

      cart = cart .. indent .. field

      if type(value) ~= "table" then
         cart = cart .. " = " .. basicSerialize(value) .. ";\n"
      else
         if saved[value] then
            cart = cart .. " = {}; -- " .. saved[value] 
                        .. " (self reference)\n"
            autoref = autoref ..  name .. " = " .. saved[value] .. ";\n"
         else
            saved[value] = name
            --if tablecount(value) == 0 then
            if isemptytable(value) then
               cart = cart .. " = {};\n"
            else
               cart = cart .. " = {\n"
               for k, v in pairs(value) do
                  k = basicSerialize(k)
                  local fname = string.format("%s[%s]", name, k)
                  field = string.format("[%s]", k)
                  -- three spaces between levels
                  addtocart(v, fname, indent .. "   ", saved, field)
               end
               cart = cart .. indent .. "};\n"
            end
         end
      end
   end

   name = name or "__unnamed__"
   if type(t) ~= "table" then
      return name .. " = " .. basicSerialize(t)
   end
   cart, autoref = "", ""
   addtocart(t, name, indent)
   return cart .. autoref
end

addModEventListener(ClockMod);
